﻿// WaveCollection.cs

using System.Collections.ObjectModel;

namespace WaveLib
{
    /// <summary>
    /// Used to manage multiple Waves
    /// </summary>
    public class WaveCollection : Collection<Wave>
    {
        /// <summary>
        /// Finds all Waves connected to the system and adds them to the collection
        /// </summary>
        public void FindAllWaves()
        {
            Wave.FindWave(WaveFound);
        }

        private bool WaveFound(string devicePath)
        {
            this.Add(new Wave(devicePath));
            return true;
        }
    }
}
