﻿// 

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WaveLib;

namespace WaveTest
{
    public partial class WaveInfo : UserControl
    {
        private delegate void UpdateWaveStateDelegate(WaveChangedEventArgs args);

        private Bitmap b = new Bitmap(180, 180, PixelFormat.Format24bppRgb);
        private Graphics g;
        private Wave mWave;

        public WaveInfo()
        {
            InitializeComponent();
            g = Graphics.FromImage(b);
        }

        public WaveInfo(Wave wm) : this()
		{
			mWave = wm;
		}

		public void UpdateState(WaveChangedEventArgs args)
		{
			BeginInvoke(new UpdateWaveStateDelegate(UpdateWaveChanged), args);
		}

        private void UpdateWaveChanged(WaveChangedEventArgs args)
        {
            WaveState ws = args.WaveState;

            clbButtons.SetItemChecked(0, ws.ButtonState.Enc1);
            clbButtons.SetItemChecked(1, ws.ButtonState.Enc2);
            clbButtons.SetItemChecked(2, ws.ButtonState.Enc3);
            clbButtons.SetItemChecked(3, ws.ButtonState.Enc4);
            clbButtons.SetItemChecked(4, ws.ButtonState.Enc5);
            clbButtons.SetItemChecked(5, ws.ButtonState.Enc6);
            clbButtons.SetItemChecked(6, ws.ButtonState.Enc7);
            clbButtons.SetItemChecked(7, ws.ButtonState.Enc8);
            clbButtons.SetItemChecked(8, ws.ButtonState.Enc9);
            clbButtons.SetItemChecked(9, ws.ButtonState.Alt);
            clbButtons.SetItemChecked(10, ws.ButtonState.B1);
            clbButtons.SetItemChecked(11, ws.ButtonState.B2);
            clbButtons.SetItemChecked(12, ws.ButtonState.B3);
            clbButtons.SetItemChecked(15, ws.ButtonState.B4);
            clbButtons.SetItemChecked(16, ws.ButtonState.B5);
            clbButtons.SetItemChecked(17, ws.ButtonState.B6);
            clbButtons.SetItemChecked(20, ws.ButtonState.B7);
            clbButtons.SetItemChecked(21, ws.ButtonState.B8);
            clbButtons.SetItemChecked(22, ws.ButtonState.B9);
            clbButtons.SetItemChecked(13, ws.ButtonState.REnc1);
            clbButtons.SetItemChecked(14, ws.ButtonState.RTr1);
            clbButtons.SetItemChecked(18, ws.ButtonState.REnc2);
            clbButtons.SetItemChecked(19, ws.ButtonState.RTr2);
            clbButtons.SetItemChecked(23, ws.ButtonState.REnc3);
            clbButtons.SetItemChecked(24, ws.ButtonState.RTr3);
            clbButtons.SetItemChecked(25, ws.ButtonState.Up);
            clbButtons.SetItemChecked(26, ws.ButtonState.Down);
            clbButtons.SetItemChecked(27, ws.ButtonState.F7);
            clbButtons.SetItemChecked(28, ws.ButtonState.F8);
            clbButtons.SetItemChecked(29, ws.ButtonState.F9);
            clbButtons.SetItemChecked(30, ws.ButtonState.F4);
            clbButtons.SetItemChecked(31, ws.ButtonState.F5);
            clbButtons.SetItemChecked(32, ws.ButtonState.F6);
            clbButtons.SetItemChecked(33, ws.ButtonState.F1);
            clbButtons.SetItemChecked(34, ws.ButtonState.F2);
            clbButtons.SetItemChecked(35, ws.ButtonState.F3);
            clbButtons.SetItemChecked(36, ws.ButtonState.Previous);
            clbButtons.SetItemChecked(37, ws.ButtonState.Next);
            clbButtons.SetItemChecked(38, ws.ButtonState.Reverse);
            clbButtons.SetItemChecked(39, ws.ButtonState.Stop);
            clbButtons.SetItemChecked(40, ws.ButtonState.Play);


            label1.Text = "Enc1 :" + ws.EncoderState.Enc1.ToString();
            label2.Text = "Enc2 :" + ws.EncoderState.Enc2.ToString();
            label3.Text = "Enc3 :" + ws.EncoderState.Enc3.ToString();
            label4.Text = "Enc4 :" + ws.EncoderState.Enc4.ToString();
            label5.Text = "Enc5 :" + ws.EncoderState.Enc5.ToString();
            label6.Text = "Enc6 :" + ws.EncoderState.Enc6.ToString();
            label7.Text = "Enc7 :" + ws.EncoderState.Enc7.ToString();
            label8.Text = "Enc8 :" + ws.EncoderState.Enc8.ToString();
            label9.Text = "Enc9 :" + ws.EncoderState.Enc9.ToString();
            label10.Text = "EncA :" + ws.EncoderState.Enc10.ToString();
            label11.Text = "EncB :" + ws.EncoderState.Enc11.ToString();
            label12.Text = "EncC :" + ws.EncoderState.Enc12.ToString();
            label13.Text = "EncD :" + ws.EncoderState.Enc13.ToString();
            label14.Text = "TR1 X:" + ws.EncoderState.Tr1.X.ToString();
            label15.Text = "TR1 Y:" + ws.EncoderState.Tr1.Y.ToString();
            label16.Text = "TR2 X:" + ws.EncoderState.Tr2.X.ToString();
            label17.Text = "TR2 Y:" + ws.EncoderState.Tr2.Y.ToString();
            label18.Text = "TR3 X:" + ws.EncoderState.Tr3.X.ToString();
            label19.Text = "TR3 Y:" + ws.EncoderState.Tr3.Y.ToString();

            label20.Text = ws.FirmwareState.Firmware.ToString();

            g.Clear(Color.LightCyan);

            g.DrawEllipse(new Pen(Color.Red), (int)(ws.EncoderState.Tr1.X + 90), (int)(90 - ws.EncoderState.Tr1.Y), 4, 4);
            g.DrawEllipse(new Pen(Color.Green), (int)(ws.EncoderState.Tr2.X + 90), (int)(90 - ws.EncoderState.Tr2.Y), 4, 4);
            g.DrawEllipse(new Pen(Color.Blue), (int)(ws.EncoderState.Tr3.X + 90), (int)(90 - ws.EncoderState.Tr3.Y), 4, 4);

            pbIR.Image = b;
            lblDevicePath.Text = "Device Path: " + mWave.HIDDevicePath;
        }

        public Wave Wave
        {
            set { mWave = value; }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] buff = new byte[31];

            buff = ASCIIEncoding.ASCII.GetBytes(textBox1.Text);
            mWave.WriteLED(0, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox2.Text);
            mWave.WriteLED(0, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox3.Text);
            mWave.WriteLED(0, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox4.Text);
            mWave.WriteLED(0, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox5.Text);
            mWave.WriteLED(0, 4, 0, 0, buff);

            buff = ASCIIEncoding.ASCII.GetBytes(textBox10.Text);
            mWave.WriteLED(1, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox9.Text);
            mWave.WriteLED(1, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox8.Text);
            mWave.WriteLED(1, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox7.Text);
            mWave.WriteLED(1, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox6.Text);
            mWave.WriteLED(1, 4, 0, 0, buff);

            buff = ASCIIEncoding.ASCII.GetBytes(textBox15.Text);
            mWave.WriteLED(2, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox14.Text);
            mWave.WriteLED(2, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox13.Text);
            mWave.WriteLED(2, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox12.Text);
            mWave.WriteLED(2, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox11.Text);
            mWave.WriteLED(2, 4, 0, 0, buff);

        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Text = "                                ";
            textBox2.Text = "                                ";
            textBox3.Text = "                                ";
            textBox4.Text = "                                ";
            textBox5.Text = "                                ";
            textBox6.Text = "                                ";
            textBox7.Text = "                                ";
            textBox8.Text = "                                ";
            textBox9.Text = "                                ";
            textBox10.Text = "                                ";
            textBox11.Text = "                                ";
            textBox12.Text = "                                ";
            textBox13.Text = "                                ";
            textBox14.Text = "                                ";
            textBox15.Text = "                                ";

            byte[] buff = new byte[31];

            buff = ASCIIEncoding.ASCII.GetBytes(textBox1.Text);
            mWave.WriteLED(0, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox2.Text);
            mWave.WriteLED(0, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox3.Text);
            mWave.WriteLED(0, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox4.Text);
            mWave.WriteLED(0, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox5.Text);
            mWave.WriteLED(0, 4, 0, 0, buff);

            buff = ASCIIEncoding.ASCII.GetBytes(textBox10.Text);
            mWave.WriteLED(1, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox9.Text);
            mWave.WriteLED(1, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox8.Text);
            mWave.WriteLED(1, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox7.Text);
            mWave.WriteLED(1, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox6.Text);
            mWave.WriteLED(1, 4, 0, 0, buff);

            buff = ASCIIEncoding.ASCII.GetBytes(textBox15.Text);
            mWave.WriteLED(2, 0, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox14.Text);
            mWave.WriteLED(2, 1, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox13.Text);
            mWave.WriteLED(2, 2, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox12.Text);
            mWave.WriteLED(2, 3, 0, 0, buff);
            buff = ASCIIEncoding.ASCII.GetBytes(textBox11.Text);
            mWave.WriteLED(2, 4, 0, 0, buff);

            textBox1.Text = "";
            textBox2.Text = "";
            textBox3.Text = "";
            textBox4.Text = "";
            textBox5.Text = "";
            textBox6.Text = "";
            textBox7.Text = "";
            textBox8.Text = "";
            textBox9.Text = "";
            textBox10.Text = "";
            textBox11.Text = "";
            textBox12.Text = "";
            textBox13.Text = "";
            textBox14.Text = "";
            textBox15.Text = "";
        }

        private void WaveInfo_Load(object sender, EventArgs e)
        {

        }
    }
}
